#include<iostream>

using namespace std;

long long a[100001];

int main(){
    int n;
    cin >> n;
    bool b=1;
    for(int i=0; i<n; i++){
        if(b) cin >> a[i];
        else a[i]=0;
        if(a[i]==0) b=0;
    }
    int t=0, min=100000000, cnt=0;
    if(a[0]==0) cout << 0 << endl;
    for(int i=1; i<n-1; i++){
        if(a[i]>a[i-1] and a[i]>a[i+1]){
            cnt++;
            if(t<min and t!=0) min=t;
            t=0;
        }
        else if(cnt>0) t++;
    }
    if(cnt>1) cout << min << endl;
    else cout << 0 << endl;
    return 0;
}
